package com.chelvc.framework.database.interceptor;

import java.math.BigInteger;

import net.sf.jsqlparser.expression.LongValue;
import net.sf.jsqlparser.expression.NullValue;
import net.sf.jsqlparser.schema.Column;

/**
 * SQL表达式工具类
 *
 * @author Woody
 * @date 2024/5/16
 */
final class Expressions {
    private Expressions() {
    }

    /**
     * 空值
     */
    public static final NullValue NULL_VALUE = new NullValue();

    /**
     * 零值
     */
    public static final LongValue ZERO_VALUE = new LongValue(0) {
        @Override
        public long getValue() {
            return 0;
        }

        @Override
        public BigInteger getBigIntegerValue() {
            return BigInteger.ZERO;
        }
    };

    /**
     * 创建人字段
     */
    public static final Column CREATOR_COLUMN = new Column("creator");

    /**
     * 创建时间字段
     */
    public static final Column CREATE_TIME_COLUMN = new Column("create_time");

    /**
     * 更新人字段
     */
    public static final Column UPDATER_COLUMN = new Column("updater");

    /**
     * 更新时间字段
     */
    public static final Column UPDATE_TIME_COLUMN = new Column("update_time");

    /**
     * 逻辑删除字段
     */
    public static final Column DELETED_COLUMN = new Column("deleted");
}
