package com.chelvc.framework.export.config;

import com.chelvc.framework.export.ExportHandler;
import com.chelvc.framework.export.support.DefaultExportHandler;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.core.RedisTemplate;

/**
 * 数据导出配置
 *
 * @author Woody
 * @date 2024/5/10
 */
@Configuration
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
public class ExportConfigurer {
    private final com.chelvc.framework.export.config.ExportProperties properties;
    private final RedisTemplate<String, Object> redisTemplate;

    @ConditionalOnMissingBean(ExportHandler.class)
    @Bean(initMethod = "initialize", destroyMethod = "destroy")
    public ExportHandler exportHandler() {
        return new DefaultExportHandler(this.redisTemplate, this.properties);
    }
}
